;##########################################################################
.386
.model flat, stdcall
option casemap:none
title BITMAP 16
;##########################################################################
include C:\masm32\include\windows.inc
include C:\masm32\include\kernel32.inc
include C:\masm32\include\user32.inc
include C:\masm32\include\gdi32.inc
include C:\masm32\include\comdlg32.inc
includelib C:\masm32\lib\kernel32.lib
includelib C:\masm32\lib\user32.lib
includelib C:\masm32\lib\gdi32.lib
includelib C:\masm32\lib\comdlg32.lib
;##########################################################################
szText MACRO Name, Text:VARARG
LOCAL lbl
	jmp	lbl
	Name	db	Text, 0
lbl:
ENDM
m2m MACRO M1, M2
	push	M2
	pop	M1
ENDM
m2mx MACRO M1, M2
	mov	eax, M2
	mov	M1, eax
ENDM
return MACRO RETVALUE
	mov	eax, RETVALUE
	ret
ENDM
iif MACRO condition, if_true, if_false, return
	.if condition
		mov	return, if_true
	.else
		mov	return, if_false
	.endif
ENDM
iifs MACRO condition, if_true, if_false, return
	mov	return, if_false
	.if condition
		mov	return, if_true
	.endif
ENDM
zerob MACRO mem, len
	mov	edi, mem
	mov	ecx, len
	xor	al, al
	rep	stosb
ENDM
zerow MACRO mem, len
	mov	edi, mem
	mov	ecx, len / 2
	xor	ax, ax
	rep	stosw
ENDM
zerod MACRO mem, len
	mov	edi, mem
	mov	ecx, len / 4
	xor	eax, eax
	rep	stosd
ENDM
moveb MACRO dest, src, len
	mov	esi, src
	mov	edi, dest
	mov	ecx, len
	rep	movsb
ENDM
movew MACRO dest, src, len
	mov	esi, src
	mov	edi, dest
	mov	ecx, len / 2
	rep	movsw
ENDM
moved MACRO dest, src, len
	mov	esi, src
	mov	edi, dest
	mov	ecx, len / 4
	rep	movsd
ENDM
;##########################################################################
;##########################################################################
;##########################################################################
WndProc		PROTO:DWORD,:DWORD,:DWORD,:DWORD
DoEvents	PROTO
;##########################################################################
.const
	szAppTitle	db		"BITMAP 16", 0
	szMsgAbout	db		"BITMAP 16", 13, 10
			db		"Version 1.0", 13, 10
			db		"Coded by comrade <comrade2k@hotmail.com>", 13, 10, 13, 10
			db		"Homepage: http://www.comrade64.com/", 13, 10
			db		"http://comrade64.cjb.net/", 13, 10
			db		"IRC: #coders on EFnet", 0
	szImageFilter	db		"Bitmaps (*.bmp;*.dib)", 0, "*.bmp;*.dib", 0
			db		"All Files (*.*)", 0, "*.*", 0, 0
	szOutputFilter	db		"Binaries (*.bin)", 0, "*.bin", 0
			db		"All Files (*.*)", 0, "*.*", 0, 0
	szProgressFrmt	db		"%lu", 0
	szProgressSave	db		"Saving", 0
	szProgressDone	db		"Done", 0
;##########################################################################
.data
	ofn		OPENFILENAME	<sizeof OPENFILENAME, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0>
;##########################################################################
.data?
	hBitmap		dd		?

	szImage		db		256 dup (?)
	szOutput	db		256 dup (?)
	rc		RECT		<>
;##########################################################################
.code
start:	invoke	GetModuleHandle, 0
	mov	[ofn.hInstance], eax
	invoke	DialogBoxParam, eax, 100, 0, ADDR WndProc, eax
	invoke	ExitProcess, eax
;#########################################################################
WndProc proc hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
	.if [uMsg]==WM_INITDIALOG
		m2m	[ofn.hwndOwner], [hWnd]
	.elseif [uMsg]==WM_COMMAND
		mov	eax, [wParam]
		.if ax==103
			mov	[ofn.lpstrFilter], OFFSET szImageFilter
			mov	[ofn.lpstrFile], OFFSET szImage
			mov	[ofn.nMaxFile], sizeof szImage
			invoke	GetOpenFileName, ADDR ofn
			test	eax, eax
			jz	@@quit
			invoke	SetDlgItemText, [hWnd], 102, ADDR szImage
		.elseif ax==105
			mov	[ofn.lpstrFilter], OFFSET szOutputFilter
			mov	[ofn.lpstrFile], OFFSET szOutput
			mov	[ofn.nMaxFile], sizeof szOutput
			invoke	GetSaveFileName, ADDR ofn
			test	eax, eax
			jz	@@quit
			invoke	SetDlgItemText, [hWnd], 104, ADDR szOutput
		.elseif ax==110
			invoke	GetDlgItemText, [hWnd], 102, ADDR szImage, sizeof szImage
			test	eax, eax
			jz	@@quit
			invoke	GetDlgItemText, [hWnd], 104, ADDR szOutput, sizeof szOutput
			test	eax, eax
			jz	@@quit
			invoke	LoadImage, 0, ADDR szImage, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE OR LR_CREATEDIBSECTION
			test	eax, eax
			jz	@@quit
			mov	[hBitmap], eax
			push	eax
			invoke	GetObject, eax, sizeof BITMAP, ADDR [szImage+12]
			test	eax, eax
			jz	@@quit
			mov	eax, dword ptr [szImage+12][BITMAP.bmWidth]
			mul	dword ptr [szImage+12][BITMAP.bmHeight]
			add	eax, eax
			mov	dword ptr [szImage], eax
			invoke	GlobalAlloc, GMEM_MOVEABLE, eax
			mov	dword ptr [szImage+4], eax
			invoke	GlobalLock, eax
			mov	dword ptr [szImage+8], eax
			push	edi
			push	esi
			push	ebx
			mov	edi, eax
			mov	esi, dword ptr [szImage+12][BITMAP.bmBits]
			mov	ecx, dword ptr [szImage+12][BITMAP.bmHeight]
		@@y:	push	esi
			mov	edx, dword ptr [szImage+12][BITMAP.bmWidth]
			@@x:	mov	eax, [esi]
				mov	ebx, [esi]
				shr	eax, 3
				shr	ebx, 5
				and	eax, 0000000000011111b
				and	ebx, 0000011111100000b
				or	eax, ebx
				mov	ebx, [esi]
				shr	ebx, 8
				and	ebx, 1111100000000000b
				or	eax, ebx
				mov	[edi], ax
				add	esi, 3
				add	edi, 2
				dec	edx
				jnz	@@x
			pop	esi
			add	esi, dword ptr [szImage+12][BITMAP.bmWidthBytes]	; 1624
			dec	ecx
			jnz	@@y
			pop	ebx
			pop	esi
			pop	edi
			call	DeleteObject

			invoke	SetDlgItemText, [hWnd], 108, ADDR szProgressSave

			xor	eax, eax
			invoke	CreateFile, ADDR szOutput, GENERIC_WRITE, eax, eax, CREATE_ALWAYS, eax, eax
			cmp	eax, INVALID_HANDLE_VALUE
			je	@@quit
			push	eax
			invoke	WriteFile, eax, dword ptr [szImage+8], dword ptr [szImage], ADDR [szImage+12], 0
			call	CloseHandle

			mov	eax, dword ptr [szImage+4]
			push	eax
			invoke	GlobalUnlock, eax
			call	GlobalFree

			invoke	SetDlgItemText, [hWnd], 108, ADDR szProgressDone
		.elseif ax==111
			invoke	MessageBox, [hWnd], ADDR szMsgAbout, ADDR szAppTitle, MB_OK OR MB_ICONASTERISK OR MB_APPLMODAL
		.endif
	.elseif [uMsg]==WM_CLOSE
		invoke	EndDialog, [hWnd], 0
	.endif
@@quit:	xor	eax, eax
	ret
WndProc endp
;#########################################################################
DoEvents proc
	LOCAL msg:MSG

@@peek:	xor	eax, eax
	invoke	PeekMessage, ADDR msg, eax, eax, eax, PM_REMOVE
	test	eax, eax
	jz	@@done
	lea	eax, [msg]
	push	eax
	invoke	TranslateMessage, eax
	call	DispatchMessage
	jmp	@@peek
@@done:	ret
DoEvents endp
;##########################################################################
;##########################################################################
;##########################################################################
end start