;##########################################################################
.386
.model flat, stdcall
option casemap:none
title BITMAP 4
;##########################################################################
include C:\masm32\include\windows.inc
include C:\masm32\include\kernel32.inc
include C:\masm32\include\user32.inc
include C:\masm32\include\gdi32.inc
include C:\masm32\include\comdlg32.inc
includelib C:\masm32\lib\kernel32.lib
includelib C:\masm32\lib\user32.lib
includelib C:\masm32\lib\gdi32.lib
includelib C:\masm32\lib\comdlg32.lib
;##########################################################################
szText MACRO Name, Text:VARARG
LOCAL lbl
	jmp	lbl
	Name	db	Text, 0
lbl:
ENDM
m2m MACRO M1, M2
	push	M2
	pop	M1
ENDM
m2mx MACRO M1, M2
	mov	eax, M2
	mov	M1, eax
ENDM
return MACRO RETVALUE
	mov	eax, RETVALUE
	ret
ENDM
iif MACRO condition, if_true, if_false, return
	.if condition
		mov	return, if_true
	.else
		mov	return, if_false
	.endif
ENDM
iifs MACRO condition, if_true, if_false, return
	mov	return, if_false
	.if condition
		mov	return, if_true
	.endif
ENDM
zerob MACRO mem, len
	mov	edi, mem
	mov	ecx, len
	xor	al, al
	rep	stosb
ENDM
zerow MACRO mem, len
	mov	edi, mem
	mov	ecx, len / 2
	xor	ax, ax
	rep	stosw
ENDM
zerod MACRO mem, len
	mov	edi, mem
	mov	ecx, len / 4
	xor	eax, eax
	rep	stosd
ENDM
moveb MACRO dest, src, len
	mov	esi, src
	mov	edi, dest
	mov	ecx, len
	rep	movsb
ENDM
movew MACRO dest, src, len
	mov	esi, src
	mov	edi, dest
	mov	ecx, len / 2
	rep	movsw
ENDM
moved MACRO dest, src, len
	mov	esi, src
	mov	edi, dest
	mov	ecx, len / 4
	rep	movsd
ENDM
;##########################################################################
;##########################################################################
;##########################################################################
WndProc		PROTO:DWORD,:DWORD,:DWORD,:DWORD
DoEvents	PROTO
;##########################################################################
.const
	szAppTitle	db		"BITMAP 4", 0
	szMsgAbout	db		"BITMAP 4", 13, 10
			db		"Version 1.0", 13, 10
			db		"Coded by comrade <comrade2k@hotmail.com>", 13, 10, 13, 10
			db		"Homepage: http://www.comrade64.com/", 13, 10
			db		"http://comrade64.cjb.net/", 13, 10
			db		"IRC: #coders on EFnet", 0
	szImageFilter	db		"Bitmaps (*.bmp;*.dib)", 0, "*.bmp;*.dib", 0
			db		"All Files (*.*)", 0, "*.*", 0, 0
	szOutputFilter	db		"Binaries (*.bin)", 0, "*.bin", 0
			db		"All Files (*.*)", 0, "*.*", 0, 0
	szProgressFrmt	db		"%lu", 0
	szProgressSave	db		"Saving", 0
	szProgressDone	db		"Done", 0
;##########################################################################
.data
	ofn		OPENFILENAME	<sizeof OPENFILENAME, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0>
;##########################################################################
.data?
	hBitmap		dd		?
	hMemoryBitmap	dd		?
	hMemoryOutput	dd		?
	dwBitmap	dd		?
	dwOutput	dd		?

	szImage		db		256 dup (?)
	szOutput	db		256 dup (?)
	rc		RECT		<>
;##########################################################################
.code
start:	invoke	GetModuleHandle, 0
	mov	[ofn.hInstance], eax
	invoke	DialogBoxParam, eax, 100, 0, ADDR WndProc, eax
	invoke	ExitProcess, eax
;#########################################################################
WndProc proc hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
	.if [uMsg]==WM_INITDIALOG
		m2m	[ofn.hwndOwner], [hWnd]
	.elseif [uMsg]==WM_COMMAND
		mov	eax, [wParam]
		.if ax==103
			mov	[ofn.lpstrFilter], OFFSET szImageFilter
			mov	[ofn.lpstrFile], OFFSET szImage
			mov	[ofn.nMaxFile], sizeof szImage
			invoke	GetOpenFileName, ADDR ofn
			test	eax, eax
			jz	@@quit
			invoke	SetDlgItemText, [hWnd], 102, ADDR szImage
		.elseif ax==105
			mov	[ofn.lpstrFilter], OFFSET szOutputFilter
			mov	[ofn.lpstrFile], OFFSET szOutput
			mov	[ofn.nMaxFile], sizeof szOutput
			invoke	GetSaveFileName, ADDR ofn
			test	eax, eax
			jz	@@quit
			invoke	SetDlgItemText, [hWnd], 104, ADDR szOutput
		.elseif ax==110
			invoke	GetDlgItemText, [hWnd], 102, ADDR szImage, sizeof szImage
			invoke	CreateFile, ADDR szImage, GENERIC_READ, FILE_SHARE_READ, 0, OPEN_EXISTING, 0, 0
			push	eax
			invoke	GetFileSize, eax, 0
			push	eax
			invoke	GlobalAlloc, GMEM_MOVEABLE, eax
			mov	[hMemoryBitmap], eax
			invoke	GlobalLock, eax
			mov	[dwBitmap], eax
			pop	ecx
			mov	edx, [esp]
			invoke	ReadFile, edx, eax, ecx, ADDR rc, 0
			call	CloseHandle

			mov	eax, [dwBitmap]
			add	eax, [eax][BITMAPFILEHEADER.bfOffBits]
			mov	dword ptr [szOutput], eax
			sub	eax, 40h
			mov	dword ptr [szOutput+4], eax
			and	dword ptr [szOutput+8], 0

			invoke	GlobalAlloc, GMEM_MOVEABLE, 513	;36952	;52606
			mov	[hMemoryOutput], eax
			invoke	GlobalLock, eax
			mov	[dwOutput], eax

			push	esi
			push	edi
			push	ebx

			mov	esi, [dwBitmap]
			;mov	esi, dword ptr [szOutput+4]
			mov	edi, eax
			add	esi, 36h
			mov	ecx, 40h
		@@cpal:	mov	eax, [esi]
			mov	ebx, [esi]
			shr	eax, 3
			shr	ebx, 5
			and	eax, 0000000000011111b
			and	ebx, 0000011111100000b
			or	eax, ebx
			mov	ebx, [esi]
			shr	ebx, 8
			and	ebx, 1111100000000000b
			or	eax, ebx
			mov	[edi], ax
			add	esi, 4
			add	edi, 2
			sub	ecx, 4
			jnz	@@cpal

			;mov	ecx, 962	;36920 shr 2
			;rep	movsb		;rep	movsd

			mov	ecx, 37		;130	;194
		@@y:	push	esi
			mov	edx, 26		;568	;542
			@@x:	mov	al, [esi]
				mov	[edi], al
				inc	esi
				inc	edi
				sub	edx, 2
				jnz	@@x
			pop	esi
			add	esi, 16		;284	;272
			dec	ecx
			jnz	@@y


			pop	ebx
			pop	edi
			pop	esi
			invoke	SetDlgItemText, [hWnd], 108, ADDR szProgressSave
			invoke	GetDlgItemText, [hWnd], 104, ADDR szOutput, sizeof szOutput
			invoke	CreateFile, ADDR szOutput, GENERIC_WRITE, 0, 0, CREATE_ALWAYS, 0, 0
			push	eax
			invoke	WriteFile, eax, [dwOutput], 513, ADDR rc, 0	; 36952 ;52606
			call	CloseHandle
			mov	eax, [hMemoryOutput]
			push	eax
			invoke	GlobalUnlock, eax
			call	GlobalFree
			mov	eax, [hMemoryBitmap]
			push	eax
			invoke	GlobalUnlock, eax
			call	GlobalFree
			invoke	SetDlgItemText, [hWnd], 108, ADDR szProgressDone
		.elseif ax==111
			invoke	MessageBox, [hWnd], ADDR szMsgAbout, ADDR szAppTitle, MB_OK OR MB_ICONASTERISK OR MB_APPLMODAL
		.endif
	.elseif [uMsg]==WM_CLOSE
		invoke	EndDialog, [hWnd], 0
	.endif
@@quit:	xor	eax, eax
	ret
WndProc endp
;#########################################################################
DoEvents proc
	LOCAL msg:MSG

@@peek:	xor	eax, eax
	invoke	PeekMessage, ADDR msg, eax, eax, eax, PM_REMOVE
	test	eax, eax
	jz	@@done
	lea	eax, [msg]
	push	eax
	invoke	TranslateMessage, eax
	call	DispatchMessage
	jmp	@@peek
@@done:	ret
DoEvents endp
;##########################################################################
;##########################################################################
;##########################################################################
end start